#ifndef CHAOS_H
#define CHAOS_H

#include <iostream>
#include <string>
#include <sstream>
#include <stdlib.h>
#include <cmath>
#include <fstream>
#include <exception>
#include <cctype>
#include <limits>
#include <iomanip>
#include <time.h>

#define MAX_DELKA 10000//maximalni delka vygenerovaneho vektoru
#define POCET_GENEROVANYCH 20000 //pocet cisel vypsanych celkove do souboru

using namespace std;

class chaos
{
    private:
        double polex[MAX_DELKA],poley[MAX_DELKA];
        double a,d, alfa,beta,gamma,fi,uhel,delta,b,k,maximum1;
        string system;
        int i,r;
    public:
        chaos(void);

        inline void nastav_r(int r0) {r=r0;}
        inline void vyber_s(string s) { system=s;}

        void Lozi();
        void Ikeda();
        void Sinai();
        void Disipative();
        void ArnoldCat();

        void Henon();
        void Burgers();
        void HolmesCubic();
        void Chirikov();

        void max(void);
        void uloz();   //vypis do souboru
        void reev(void);

        inline double getX(int index){ return polex[index]; }
        inline double getY(int index){ return poley[index]; }
        inline double getMax(){ return maximum1; }

        void vyberSystem(int volba);
};

#endif // CHAOS_H
