#include "../include/chaos.h"
#include <iostream>
#include <string>
#include <sstream>
#include <stdlib.h>
#include <cmath>
#include <fstream>
#include <exception>
#include <cctype>
#include <limits>
#include <iomanip>
#include <time.h>

#define PI 3.14//konstanta pi


using namespace std;

int posledni;//globalni promenna pro zapamatovani posledni volby z menu

//konstruktor
chaos::chaos()
{
    a=0;
    d=0;
    alfa=0;
    beta=0;
    gamma=0;
    fi=0;
    uhel=0;
    delta=0;
    maximum1=0;
    b=0;
    k=0;
    system="";
    i=0;
    r=1;
}

void chaos::max()
{
    for(i=0;i<MAX_DELKA;i++)
    {
        if (fabs(polex[i])>maximum1)
        maximum1=fabs(polex[i]);
    }
}

//funkce obsluhujici druhou vrstvu menu po vyberu systemu
void chaos::uloz()
{
    int indexv=0, i;
    ofstream soubor;
    max();

    //vypis do souboru
    soubor.open("chaos.txt");
    if (!soubor.is_open())
    {
        cout<<"Nelze otevrit vystupni soubor"<<endl;
        return;
    }
    soubor<<"i"<<"\tx"<<"\t\t\ty"<<endl;
    for(i=1; i<POCET_GENEROVANYCH; i++)
    {
        //nastaveni hodnot x, aby byly pouze v intervalu 0 - 1
        polex[i]=fabs(polex[i])/maximum1;

        if (i == MAX_DELKA)
        {
            indexv=0;
            reev();
        }
        indexv++;
        soubor<<i<<"\t"<<setw(8)<<setfill('0')<<left<<polex[indexv]<<"\t\t"<<setw(8)<<setfill('0')<<left<<poley[indexv]<<endl;
    }
    soubor.close();
    cout<<"Vygenerovane hodnoty chaotickeho chaosu cisel byly uspesne ulozeny do souboru."<<endl;
}

//funkce obsluhujici system Ikeda
void chaos::Lozi()
{
   //pocatecni podminky:
    polex[0]= -0.6 + (time(NULL)%10/25.0);
    poley[0]= 0.05 + (time(NULL)%100/1000.0);

    //parametry:
    a=1.7;          //a z intervalu >1.5
    b=0.5;          //b z intervalu -0.7 do 0.7

    for(i=1;i<MAX_DELKA;i++)
    {
        poley[i]=polex[i-1];
        polex[i]=1-a*fabs(polex[i-1])+b*poley[i-1];
    }
}
//funkce obsluhujici system Ikeda
void chaos::Ikeda()
{
    //pocatecni podminky:
    polex[0]= -0.5 + (time(NULL)%10/10.0);      //z intervalu -0.5 do 0.5
    poley[0]= -0.5 + (time(NULL)%100/100.0);

    alfa=6;
    beta=0.4;
    gamma=1;
    fi=0.9;
    for(i=1;i<MAX_DELKA;i++)
    {
        uhel=beta-alfa/(1+polex[i-1]*polex[i-1]+poley[i-1]*poley[i-1]);
        poley[i]=fi*(polex[i-1]*sin(uhel)+poley[i-1]*cos(uhel));
        polex[i]=gamma+fi*(polex[i-1]*cos(uhel)-poley[i-1]*sin(uhel));
    }
}
//funkce obsluhujici system Sinai
void chaos::Sinai()
{

    //pocatecni podminky:
    polex[0]= 0.1 + (time(NULL)%10/10.0);       //jakekoliv poc.podminky krome nuly
    poley[0]= 0.1 + (time(NULL)%100/100.0);     //jakekoliv poc.podminky krome nuly

    delta=0.1;

    for(i=1;i<MAX_DELKA;i++)
    {
        poley[i]=fmod(polex[i-1]+2*poley[i-1],1.0);
        polex[i]=fmod(polex[i-1]+poley[i-1]+delta*cos(2*PI*poley[i-1]),1.0);
    }
}
//funkce obsluhujici disipativni system
void chaos::Disipative()
{
    polex[0]= 0.1+(time(NULL)%10/100.0);     //jakekoliv poc.podminky krome nuly
    poley[0]= 0.1+(time(NULL)%100/1000.0);   //jakekoliv poc.podminky krome nuly

    b=0.1;
    k=8.8;

    for(i=1;i<MAX_DELKA;i++)
    {
        poley[i]=fmod(b*poley[i-1]+k*sin(polex[i-1]),2*PI);
        polex[i]=fmod(polex[i-1]+poley[i],2*PI);
    }
}
//funkce obsluhujici system Arnold Cat map
void chaos::ArnoldCat()
{
    polex[0]= -0.01+(time(NULL)%10/100.0);
    poley[0]= 0.2+(time(NULL)%100/100.0);

    k=2;

    for(i=1;i<MAX_DELKA;i++)
    {
        poley[i]=fmod(polex[i-1]+k*poley[i-1],1.0);
        polex[i]=fmod(polex[i-1]+poley[i-1],1.0);
    }
}
//funkce obsluhujici system Henon map
void chaos::Henon()
{
    polex[0]= -0.5+(time(NULL)%10/10.0);
    poley[0]= 0.9;

    a=1.4;
    b=0.3;

    for(i=1;i<MAX_DELKA;i++)
    {
        poley[i]=polex[i-1];
        polex[i]=1-a*polex[i-1]*polex[i-1]+b*poley[i-1];
    }
}
//funkce obsluhujici system Burgers map
void chaos::Burgers()
{
    polex[0]= -0.2+(time(NULL)%10/100.0);
    poley[0]= 0.1;

    a=0.75;
    b=1.75;

    for(i=1;i<MAX_DELKA;i++)
    {
        poley[i]=b*poley[i-1]+polex[i-1]*poley[i-1];
        polex[i]=a*polex[i-1]-poley[i-1]*poley[i-1];
    }
}
//funkce obsluhujici system Holmes Cubic map
void chaos::HolmesCubic()
{
    polex[0]= 1.3+(time(NULL)%10/20.0);
    poley[0]= 0.1;

    b=0.2;
    d=2.77;

    for(i=1;i<MAX_DELKA;i++)
    {
        poley[i]=-b*polex[i-1]+d*poley[i-1]-poley[i-1]*poley[i-1]*poley[i-1];
        polex[i]=poley[i-1];
    }
}
//funkce obsluhujici system chirikov
void chaos::Chirikov()
{
    polex[0]= -0.5+(time(NULL)%10/10.0);
    poley[0]= 6;

    k=1;

    for(i=1;i<MAX_DELKA;i++)
    {
        poley[i]=fmod(poley[i-1]+k*sin(polex[i-1]),2*PI);
        polex[i]=fmod(polex[i-1]+poley[i],2*PI);
    }
}
//funkce zajistujici pokracovani pocitani i kdyz funkce
// dojde do konce vygenerovanehoi intervalu
void chaos::reev()
{
    max();
    r++;

    switch(posledni)
    {
        case 1:
            Lozi();
            break;
        case 2:
            Disipative();
            break;
        case 3:
            Sinai();
            break;
        case 4:
            Ikeda();
            break;
        case 5:
            ArnoldCat();
            break;
        case 6:
            Henon();
            break;
        case 7:
            Burgers();
            break;
        case 8:
            HolmesCubic();
            break;
        case 9:
            Chirikov();
            break;
    }
}

void chaos::vyberSystem(int volba)
{
    nastav_r(1);//pokud se zacina znovu generovat resetuj pocet reevaluaci

    if ((volba>=1) && (volba <=9)){
        switch(volba)
        {
            case 1://system Lozi
                vyber_s("Lozi");
                Lozi();
                break;
             case 2:////disipativni system
                vyber_s("Disipative");
                Disipative();
                break;

             case 3://system Sinai
                vyber_s("Sinai");
                Sinai();
                break;
             case 4:
               vyber_s("Ikeda");
                Ikeda();
                break;
             case 5://System Arnold cat map
                vyber_s("Arnold Cat");
                ArnoldCat();
                break;
            case 6://Henon map
                vyber_s("Henon");
                Henon();
                break;
            case 7://Burgers map
                vyber_s("Burgers");
                Burgers();
                break;
            case 8://Holmes cubic map
                vyber_s("Holmes cubic");
                HolmesCubic();
                break;
            case 9://System Chirikov
                vyber_s("Chirikov");
                Chirikov();
                break;
            default:
                cout<<"Chybne zadani"<<endl<<endl;
                break;
        }
    }
    else
        cout<<"Chybne zadani"<<endl<<endl;
}
